//#include <stdio.h> // probably need these at some point
//#include <stdlib.h>


#define IDLE 0
#define PBGoingDOWN 1
#define PBDOWN 2
#define PBGoingUP 3
#define PBUP 4
int8 IPBState = IDLE;  // State var for pb machine
int1 IPB = FALSE; // pushbutton pressed flag



 ext_int_edge(H_to_L);        // ext int 0, pushbutton  RB0
 enable_interrupts(INT_EXT);  // enable the interrupt

/////////////////
#int_EXT
void PB_interrupt()
{
 IPB=TRUE; // just set a flag for the background code
}
////////////////////////




  switch (IPBState)
   {
    case IDLE: // looking for work
    {
    if (IPB) //button pressed flag
    { // so go to next state, clear flag
     IPB = FALSE;
     Ipbcntr = 0;
     IPBState = PBGoingDOWN;
    }
    break;
    }
    case PBGoingDOWN:
    { // waiting for the inevitable bouncing
     if ( FALSE == input_B() & 1)  Ipbcntr++;  // keep track of how long we wait
     else Ipbcntr--; // or how long -- if never down long enough, skip the mess
     
     if (Ipbcntr > BOUNCETICKS)
      {
       IPBState = PBDOWN;
       bPBflag = TRUE; // flag background, just this one time
       enable_interrupts(INT_EXT); // re-enable the interrupt
      } else if (Ipbcntr < BOUNCETICKS) IPBState = IDLE; 
       // just got one hit, but never saw real button press, ABORT!
       
      
     break;
    }
    case PBDOWN:
    {
     if (Ipbcntr < 127) IPBcntr++;  // we may want to flag background for cont press
     if (input_B() & 1) IPBState = PBGoingUP;
     break;
    }
    case PBGoingUP:
    {
     break;
    }
    default:
    case PBUP:
    {
     IPBState = IDLE;
     break;
    }
   }
   
   
   //////////////////////////////////**********
   // enable_interrupts(INT_RB);   // for rotary encoder switches

#bit REa = IRErd.0
#bit REb = IRErd.1
#bit REd = IRET.0
#int_RB
void rot_enc_interrupt() // why not use a long name, never have to type it again!
{
IRErd = (input_B() & 0x30) >> 4; // easier on my head to shift bits down
if (IRErd != IRErdz) // an actual, valid?, change occurred
{
 IRET = IRErd ^ IRErdZ; // diff between this and previous grey code
 IREDIR = (REa ^ REb) ^ REd;  // xor of current state bits, then change bit

 IRErdZ = IRErd; // make the same again, for next change test
 bREflag=TRUE; // set a flag for background
}
// IrdPB= input_B(); // always clear the interrupt flag, dummy read
}

